// Ambient.h
// (c) 2003-2004 exeal

#ifndef _AMBIENT_H_
#define _AMBIENT_H_

#include "AmbientIdl.h"	// generated from AmbientIdl.idl
#include "Alpha.h"
#include "KeyboardMap.h"
#include "..\Armaiti\DispatchImpl.h"
#include <dispex.h>
using namespace Armaiti;
using namespace Armaiti::OLE;

interface IActiveScript;


namespace Ascension {
	class CClipboardRing;
}

namespace Alpha {

class CAlphaApp;
class CAlphaDoc;
class CAlphaView;
class CAlphaScriptHost;
class CEnumImpl;


namespace Ambient {

// CAlphaTypeLibPath class definition and implementation
/////////////////////////////////////////////////////////////////////////////////

///	^CvCũpXێ
class CAlphaTypeLibPath {
public:
	static const OLECHAR*	GetPath() {
		return OLESTR("Alpha.tlb");
	}
};


// CDispatchEnumerator class definition
/////////////////////////////////////////////////////////////////////////////////

///	IEnumVARIANT ̎
class CDispatchEnumerator :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IEnumVARIANT {
	// RXgN^
public:
	CDispatchEnumerator(IDispatch** parrObjects, size_t cObjects);
	virtual ~CDispatchEnumerator();
private:
	CDispatchEnumerator(const CDispatchEnumerator& rhs);
	operator = (const CDispatchEnumerator& rhs);

	// \bh
public:

	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IEnumVARIANT)
	END_INTERFACE_TABLE()

	// IEnumVARIANT C^[tFCX
	STDMETHODIMP	Next(ULONG celt, VARIANT *rgVar, ULONG *pCeltFetched);
	STDMETHODIMP	Skip(ULONG celt);
	STDMETHODIMP	Reset();
	STDMETHODIMP	Clone(IEnumVARIANT **ppEnum);

	// f[^o
private:
	list<IDispatch*>			m_listObjects;
	list<IDispatch*>::iterator	m_it;
};


// CApplication class definition
/////////////////////////////////////////////////////////////////////////////////

///	IApplication ̎
class CApplication :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IApplication,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IApplication>
		>,
		public ISupportErrorInfoImpl<&IID_IApplication>/*,
		public IProvideClassInfo2Impl<&CLSID_Application, &IID_IApplication, &LIBID_Alpha>*/ {
	friend class CAlphaDoc;
	friend class CAlphaView;
	friend class CAlphaApp;

	// RXgN^
private:
	CApplication(CAlphaApp& app, const vector<wstring>* pvecArguments = 0);
public:
	~CApplication();

	// \bh
public:
	static void	GetEnumerations(set<pair<wstring, CEnumImpl*> >& enums);

	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IApplication)
//		IMPLEMENTS_INTERFACE(IDispatchEx)
		IMPLEMENTS_INTERFACE(IDispatch)
		IMPLEMENTS_INTERFACE(ISupportErrorInfo)
//		IMPLEMENTS_INTERFACE(IProvideClassInfo2)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IDispatchEx C^[tFCX
/*	STDMETHODIMP	GetDispID(BSTR bstrName, DWORD grfdex, DISPID* pid);
	STDMETHODIMP	InvokeEx(DISPID id, LCID lcid, WORD wFlags, DISPPARAMS* pdp,
						VARIANT* pvarRes, EXCEPINFO* pei, IServiceProvider* pspCaller);
	STDMETHODIMP	DeleteMemberByName(BSTR bstrName, DWORD grfdex);
	STDMETHODIMP	DeleteMemberByDispID(DISPID id);
	STDMETHODIMP	GetMemberProperties(DISPID id, DWORD grfdexFetch, DWORD* pgrfdex);
	STDMETHODIMP	GetMemberName(DISPID id, BSTR* pbstrName);
	STDMETHODIMP	GetNextDispID(DWORD grfdex, DISPID id, DISPID* pid);
	STDMETHODIMP	GetNameSpaceParent(IUnknown** ppunk);
*/
	// IApplication C^[tFCX
    STDMETHODIMP	get_Active(VARIANT_BOOL* pbActive);
    STDMETHODIMP	put_Active(VARIANT_BOOL bActive);
    STDMETHODIMP	get_ActiveDocument(IDocument** ppActiveDocument);
	STDMETHODIMP	get_Configurations(IConfigurations** ppConfigurations);
    STDMETHODIMP	get_CurrentDirectory(BSTR* pbstrDirectory);
    STDMETHODIMP	put_CurrentDirectory(BSTR bstrDirectory);
//	STDMETHODIMP	get_Debugger(IDebugger** ppDebugger);
    STDMETHODIMP	get_Documents(IDocuments** ppDocuments);
	STDMETHODIMP	get_FullName(BSTR* pbstrFullName);
    STDMETHODIMP	get_Height(long* pnHeight);
    STDMETHODIMP	put_Height(long nHeight);
    STDMETHODIMP	get_Left(long* pnLeft);
    STDMETHODIMP	put_Left(long nLeft);
	STDMETHODIMP	get_KeyboardScheme(IKeyboardScheme** ppKeyboardScheme);
	STDMETHODIMP	get_Name(BSTR* pbstrName);
    STDMETHODIMP	get_Top(long* pnTop);
    STDMETHODIMP	put_Top(long nTop);
	STDMETHODIMP	get_Version(BSTR* pbstrVersion);
    STDMETHODIMP	get_Visible(VARIANT_BOOL* pbVisible);
    STDMETHODIMP	put_Visible(VARIANT_BOOL bVisible);
    STDMETHODIMP	get_Width(long* pnWidth);
    STDMETHODIMP	put_Width(long nWidth);
    STDMETHODIMP	get_WindowState(AmbientWindowState* pWindowState);
    STDMETHODIMP	put_WindowState(AmbientWindowState windowState);
	STDMETHODIMP	ClearOutput();
	STDMETHODIMP	GetCommandById(long nCommandId, ICommand** ppCommand);
	STDMETHODIMP	Quit(short nErrorCode = 0);
	STDMETHODIMP	WriteToOutput(BSTR bstrOutput, VARIANT_BOOL bActivate);
	STDMETHODIMP	WriteLineToOutput(BSTR bstrOutput, VARIANT_BOOL bActivate);

private:
	void	_CallHook(DISPID idHook, const DISPPARAMS* pArguments);

	// f[^o
private:
	CAlphaApp&	m_app;
};


// CDocuments class definition
/////////////////////////////////////////////////////////////////////////////

///	IDocuments ̎
class CDocuments : 
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IDocuments,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IDocuments>
		> {
	// RXgN^
public:
	CDocuments(CAlphaApp& app);

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IDocuments)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IDocuments C^[tFCX
	STDMETHODIMP	get__NewEnum(IUnknown** ppEnum);
    STDMETHODIMP	get_Count(long* pnCount);
    STDMETHODIMP	AddNew();
    STDMETHODIMP	CloseAll();
    STDMETHODIMP	Item(long iDocument, IDocument** ppDocument);
    STDMETHODIMP	Open(BSTR bstrPathName, AmbientFileShareMode fileShareMode,
						long nCodePage = 0, VARIANT_BOOL bAddToMRU = VARIANT_TRUE);
    STDMETHODIMP	SaveAll();

	// f[^o
private:
	CAlphaApp&	m_app;
};


// CTextDocument class definition
////////////////////////////////////////////////////////////////////////////////

///	ITextDocument ̎
class CTextDocument :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ITextDocument,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ITextDocument>
		> {
	// RXgN^
public:
	CTextDocument(CAlphaApp& app, CAlphaDoc& document);

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ITextDocument)
		IMPLEMENTS_INTERFACE(IDocument)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IDocument C^[tFCX
    STDMETHODIMP	get_Active(VARIANT_BOOL* pbActive);
    STDMETHODIMP	put_Active(VARIANT_BOOL bActive);
    STDMETHODIMP	get_BreakType(AmbientBreakType* pBreakType);
    STDMETHODIMP	put_BreakType(AmbientBreakType breakType);
    STDMETHODIMP	get_CodePage(long* pnCodePage);
    STDMETHODIMP	put_CodePage(long nCodePage);
    STDMETHODIMP	get_FileName(BSTR* pbstrFileName);
    STDMETHODIMP	get_FilePath(BSTR* pbstrFilePath);
    STDMETHODIMP	get_Modified(VARIANT_BOOL* pbModified);
    STDMETHODIMP	put_Modified(VARIANT_BOOL bModified);
    STDMETHODIMP	get_ReadOnly(VARIANT_BOOL* pbReadOnly);
    STDMETHODIMP	put_ReadOnly(VARIANT_BOOL bReadOnly);
    STDMETHODIMP	ClearUndoBuffer();
    STDMETHODIMP	Close(VARIANT_BOOL bConfirm = VARIANT_TRUE);
    STDMETHODIMP	Redo();
    STDMETHODIMP	Save(BSTR bstrFileName, AmbientBreakType breakType = ABT_AUTO, long nCodePage = 0);
    STDMETHODIMP	Undo();

	// ITextDocument C^[tFCX
	STDMETHODIMP	get_EndPoint(ITextPoint** ppEndPoint);
	STDMETHODIMP	get_StartPoint(ITextPoint** ppStartPoint);
	STDMETHODIMP	get_TextProcessor(ITextProcessor** ppTextProcessor);

protected:
	unsigned int	FindDocument() const;

	// f[^o
private:
	CAlphaApp&	m_app;
	CAlphaDoc&	m_document;
};


// CTextProcessor class definition
/////////////////////////////////////////////////////////////////////////////

///	ITextProcessor ̎
class CTextProcessor : 
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ITextProcessor,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ITextProcessor>
		> {
	// RXgN^
public:
	CTextProcessor(CAlphaEditController& editor);

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ITextProcessor)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ITextProcessor C^[tFCX
	STDMETHODIMP	get_ClipboardRing(IClipboardRing** ppClipboardRing);
	STDMETHODIMP	get_Lexer(ILexer** ppLexer);
    STDMETHODIMP	get_OvertypeMode(VARIANT_BOOL* pbOvertypeMode);
    STDMETHODIMP	put_OvertypeMode(VARIANT_BOOL bOvertypeMode);
	STDMETHODIMP	get_Preferences(IEditorPreferences** ppPreferences);
    STDMETHODIMP	get_Selection(ITextSelection** ppSelection);
    STDMETHODIMP	get_TextSearcher(ITextSearcher** ppSearcher);
    STDMETHODIMP	BackSpace();
	STDMETHODIMP	BeginEditCollection();
	STDMETHODIMP	CreateEditPoint(ITextPoint* pTextPoint, IEditPoint** ppEditPoint);
    STDMETHODIMP	Delete();
	STDMETHODIMP	EndEditCollection();
    STDMETHODIMP	FindText(BSTR bstrFindWhat, AmbientFindTextFlags ftf, VARIANT_BOOL* pbFound);
    STDMETHODIMP	Indent();
    STDMETHODIMP	NewLine();
    STDMETHODIMP	Paste();
	STDMETHODIMP	PasteFromClipboardRing();
    STDMETHODIMP	Unindent();

	// f[^o
private:
	CAlphaEditController&	m_editor;
};


// CTextSelection class definition
/////////////////////////////////////////////////////////////////////////////

///	ITextSelection ̎
class CTextSelection : 
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ITextSelection,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ITextSelection>
		> {
	// RXgN^
public:
	CTextSelection(CAlphaEditController& editor);

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ITextSelection)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ITextSelection C^[tFCX
	STDMETHODIMP	get_ActiveEndGreater(VARIANT_BOOL* pbActiveEndGreater);
	STDMETHODIMP	get_ActivePoint(ITextPoint** ppActivePoint);
	STDMETHODIMP	get_AnchorPoint(ITextPoint** ppAnchorPoint);
	STDMETHODIMP	get_BottomPoint(ITextPoint** ppBottomPoint);
	STDMETHODIMP	get_Empty(VARIANT_BOOL* pbEmpty);
	STDMETHODIMP	get_Text(BSTR* pbstrText);
	STDMETHODIMP	get_TextRanges(ITextRanges** ppTextRanges);
	STDMETHODIMP	get_TopPoint(ITextPoint** ppTopPoint);
    STDMETHODIMP	Cancel();
    STDMETHODIMP	CharNext(VARIANT_BOOL bExtend = VARIANT_FALSE, long cch = 1);
    STDMETHODIMP	CharPrev(VARIANT_BOOL bExtend = VARIANT_FALSE, long cch = 1);
	STDMETHODIMP	Convert(AmbientConvertType ct);
    STDMETHODIMP	Copy(VARIANT_BOOL bAlsoSendToClipboardRing = VARIANT_TRUE);
    STDMETHODIMP	Cut(VARIANT_BOOL bAlsoSendToClipboardRing = VARIANT_TRUE);
    STDMETHODIMP	LineDown(VARIANT_BOOL bExtend = VARIANT_FALSE, long cLines = 1);
    STDMETHODIMP	LineUp(VARIANT_BOOL bExtend = VARIANT_FALSE, long cLines = 1);
    STDMETHODIMP	MoveTo(long iLine, long iChar, VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	MoveToEndOfDocument(VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	MoveToEndOfLine(VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	MoveToNextBookmark(VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	MoveToPreviousBookmark(VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	MoveToStartOfDocument(VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	MoveToStartOfLine(VARIANT_BOOL bToFirstText = VARIANT_FALSE, VARIANT_BOOL bExtend = VARIANT_FALSE);
    STDMETHODIMP	PageDown(VARIANT_BOOL bExtend = VARIANT_FALSE, long cPages = 1);
    STDMETHODIMP	PageUp(VARIANT_BOOL bExtend = VARIANT_FALSE, long cPages = 1);
	STDMETHODIMP	Paste();
	STDMETHODIMP	PasteFromClipboardRing();
    STDMETHODIMP	Replace(BSTR bstrText);
    STDMETHODIMP	SelectAll();
    STDMETHODIMP	SelectLine(long iLine);
	STDMETHODIMP	SwapAnchor();
	STDMETHODIMP	Tabify();
	STDMETHODIMP	Untabify();
    STDMETHODIMP	WordEndNext(VARIANT_BOOL bExtend = VARIANT_FALSE, long cWords = 1);
    STDMETHODIMP	WordEndPrev(VARIANT_BOOL bExtend = VARIANT_FALSE, long cWords = 1);
    STDMETHODIMP	WordNext(VARIANT_BOOL bExtend = VARIANT_FALSE, long cWords = 1);
    STDMETHODIMP	WordPrev(VARIANT_BOOL bExtend = VARIANT_FALSE, long cWords = 1);

	// f[^o
private:
	CAlphaEditController&	m_editor;
};


// CTextPoint class definition
/////////////////////////////////////////////////////////////////////////////

///	ITextPoint  IEditPoint ̎
class CTextPoint :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IEditPoint,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IEditPoint>
		> {
	// RXgN^
public:
	CTextPoint(CEditPoint& pos, bool bIsEditPoint);
	virtual ~CTextPoint();

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IEditPoint)
		IMPLEMENTS_INTERFACE(ITextPoint)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ITextPoint C^[tFCX
	STDMETHODIMP	get_AbsoluteCharOffset(long* pnAbsoluteCharOffset);
	STDMETHODIMP	get_AtEndOfDocument(VARIANT_BOOL* pbAtEndOfDocument);
	STDMETHODIMP	get_AtEndOfLine(VARIANT_BOOL* pbAtEndOfLine);
	STDMETHODIMP	get_AtStartOfDocument(VARIANT_BOOL* pbAtStartOfDocument);
	STDMETHODIMP	get_AtStartOfLine(VARIANT_BOOL* pbAtStartOfLine);
	STDMETHODIMP	get_Char(long* pnChar);
	STDMETHODIMP	get_Column(long* pnColumn);
	STDMETHODIMP	get_Line(long* pnLine);
	STDMETHODIMP	get_LineLength(long* pnLineLength);
	STDMETHODIMP	CreateEditPoint(IEditPoint** ppEditPoint);
	STDMETHODIMP	EnsureCentered(VARIANT varOther, VARIANT_BOOL* pbInEditorRect);
	STDMETHODIMP	EnsureVisible(VARIANT varOther, VARIANT_BOOL* pbInEditorRect);
	STDMETHODIMP	EqualTo(ITextPoint* pTextPoint, VARIANT_BOOL* pbEqual);
	STDMETHODIMP	GreaterThan(ITextPoint* pTextPoint, VARIANT_BOOL* pbGreater);
	STDMETHODIMP	LessThan(ITextPoint* pTextPoint, VARIANT_BOOL* pbLess);

	// IEditPoint C^[tFCX
	STDMETHODIMP	get_CharCountBehavior(AmbientCharCountBehavior* pCharCountBehavior);
	STDMETHODIMP	put_CharCountBehavior(AmbientCharCountBehavior charCountBehavior);
	STDMETHODIMP	CharNext(long cch = 1);
	STDMETHODIMP	CharPrev(long cch = 1);
	STDMETHODIMP	Convert(AmbientConvertType ct, VARIANT varOther);
	STDMETHODIMP	Copy(VARIANT varOther);
	STDMETHODIMP	Cut(VARIANT varOther);
	STDMETHODIMP	Delete(VARIANT varOther);
	STDMETHODIMP	DestructiveInsert(BSTR bstrText);
	STDMETHODIMP	GetText(VARIANT varOther, BSTR* pbstrText);
	STDMETHODIMP	Indent(VARIANT varOther, short nLevel = 1);
	STDMETHODIMP	Insert(BSTR bstrText);
	STDMETHODIMP	LineDown(long cLines = 1);
	STDMETHODIMP	LineUp(long cLines = 1);
	STDMETHODIMP	MoveTo(long iLine, long iChar);
	STDMETHODIMP	MoveToAbsoluteOffset(long nOffset);
	STDMETHODIMP	MoveToEndOfDocument();
	STDMETHODIMP	MoveToEndOfLine();
	STDMETHODIMP	MoveToNextBookmark();
	STDMETHODIMP	MoveToPreviousBookmark();
	STDMETHODIMP	MoveToStartOfDocument();
	STDMETHODIMP	MoveToStartOfLine(VARIANT_BOOL bToFirstText = VARIANT_FALSE);
	STDMETHODIMP	NewLine();
	STDMETHODIMP	PageDown(long cPages = 1);
	STDMETHODIMP	PageUp(long cPages = 1);
	STDMETHODIMP	Paste(VARIANT varOther);
	STDMETHODIMP	Replace(BSTR bstrText, VARIANT varOther);
	STDMETHODIMP	Unindent(VARIANT varOther, short nLevel = 1);
	STDMETHODIMP	WordEndNext(long cWords = 1);
	STDMETHODIMP	WordEndPrev(long cWords = 1);
	STDMETHODIMP	WordNext(long cWords = 1);
	STDMETHODIMP	WordPrev(long cWords = 1);

	// f[^o
private:
	CEditPoint&	m_pos;
	const bool	m_bIsEditPoint;
};


// CTextRange class definition
/////////////////////////////////////////////////////////////////////////////

///	ITextRange ̎
class CTextRange :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ITextRange,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ITextRange>
		> {
	// RXgN^
public:
	CTextRange(CEditPoint& pos1, CEditPoint& pos2);

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ITextRange)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ITextRange C^[tFCX
	STDMETHODIMP	get_EndPoint(ITextPoint** ppEndPoint);
	STDMETHODIMP	get_StartPoint(ITextPoint **ppStartPoint);

	// f[^o
private:
	CEditPoint&	m_pos1;
	CEditPoint&	m_pos2;
};


// CAutomationLexer class definition
/////////////////////////////////////////////////////////////////////////////

///	ILexer ̎
class CAutomationLexer :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ILexer,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ILexer>
		> {
	// RXgN^
public:
	CAutomationLexer(CLexer& impl);

	// \bh
public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ILexer)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ILexer C^[tFCX
	STDMETHODIMP	put_Freezed(VARIANT_BOOL bFreeze);
	STDMETHODIMP	put_IgnoreCase(VARIANT_BOOL bIgnoreCase);
	STDMETHODIMP	put_NumberFormat(AmbientNumberFormat numberFormat);
	STDMETHODIMP	put_TokenEnabled(BSTR bstrTokenName, VARIANT_BOOL bEnabled);
	STDMETHODIMP	put_UnicodeAlphabetsEnabled(VARIANT_BOOL bEnabled);
	STDMETHODIMP	put_UnicodeWhiteSpacesEnabled(VARIANT_BOOL bEnabled);
	STDMETHODIMP	AddKeywords(BSTR bstrKeywords, long* pnIdentifier);
	STDMETHODIMP	AddMultilineAnnotation(BSTR bstrStartDelimiter,
						BSTR bstrEndDelimiter, AmbientAnnotationRestriction ar, long* pnIdentifier);
	STDMETHODIMP	AddSinglelineAnnotation(BSTR bstrStartDelimiter,
						BSTR bstrEndDelimiter, AmbientAnnotationRestriction ar, long* pnIdentifier);
	STDMETHODIMP	RemoveAll();
	STDMETHODIMP	RemoveIdentifiedToken(long nIdentified);
	STDMETHODIMP	SetAdditionalAlphabets(BSTR bstrAlphabets);
	STDMETHODIMP	SetBrackets(BSTR bstrOpeners);
	STDMETHODIMP	SetOperators(BSTR bstrOperators);

	// f[^o
private:
	CLexer&	m_impl;	// Ϗ
};


// CEditorPreferences class definition
/////////////////////////////////////////////////////////////////////////////

///	IEditorPreferences ̎
class CEditorPreferences :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IEditorPreferences,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IEditorPreferences>
		> {
	// RXgN^
public:
	CEditorPreferences(CEditView& view);

	// \bh
public:
	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IEditorPreferences)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IEditorPreferences \bh
	STDMETHODIMP	put_CharSpan(short nCharSpan);
	STDMETHODIMP	put_CloseBoldChars(VARIANT_BOOL bCloseBoldChars);
	STDMETHODIMP	put_EndOfFileLabel(BSTR bstrEndOfFileLabel);
	STDMETHODIMP	put_IdeographicSpaceAlternativeChar(short cp);
	STDMETHODIMP	put_LeftMargin(short nLeftMargin);
	STDMETHODIMP	put_LineNumberBorderStyle(AmbientLineNumberBorderStyle style);
	STDMETHODIMP	put_LineNumberBorderWidth(short nWidth);
	STDMETHODIMP	put_LineSpan(short nLineSpan);
	STDMETHODIMP	put_ResetDirectionByTokens(VARIANT_BOOL bResetDirByTokens);
	STDMETHODIMP	put_RightToLeftReading(VARIANT_BOOL bRightToLeft);
	STDMETHODIMP	put_SelectEndOfLine(VARIANT_BOOL bSelectEndOfLine);
	STDMETHODIMP	put_ShowCurrentUnderline(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowEndOfFile(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowEndOfLine(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowHandOnLink(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowHintOnLink(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowIndicatorMargin(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowLineNumber(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowUnicodeDirectionFormatter(VARIANT_BOOL bShow);
	STDMETHODIMP	put_ShowWhiteSpaceAlternative(VARIANT_BOOL bShow);
	STDMETHODIMP	put_StartCharNumber(long nStartCharNumber);
	STDMETHODIMP	put_StartLineNumber(long nStartLineNumber);
	STDMETHODIMP	put_TabAlternativeChar(short cp);
	STDMETHODIMP	put_TabWidth(short nTabWidth);
	STDMETHODIMP	put_ThinCaret(VARIANT_BOOL bThinCaret);
	STDMETHODIMP	get_TokenDecoration(BSTR bstrTokenTypeName, ITokenDecoration** ppTokenDecoration);
	STDMETHODIMP	put_TopMargin(short nTopMargin);
	STDMETHODIMP	put_WhiteSpaceAlternativeChar(short cp);
	STDMETHODIMP	put_WrapMode(AmbientWrapMode wrapMode);
	STDMETHODIMP	put_WrapWidth(short nWrapWidth);
	STDMETHODIMP	Reset();

	// f[^o
private:
	CEditView&	m_view;
};


// CTokenDecoration class definition
/////////////////////////////////////////////////////////////////////////////

///	ITokenDecoration ̎
class CTokenDecoration :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ITokenDecoration,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ITokenDecoration>
		> {
	// RXgN^
public:
	CTokenDecoration(CEditView& view, int nTokenType, TokenCookie nTokenCookie = NullCookie);

	// \bh
public:
	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ITokenDecoration)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ITokenDecoration \bh
	STDMETHODIMP	get_Color(long* pnColor);
	STDMETHODIMP	put_Color(long nColor);
	STDMETHODIMP	get_BackgroundColor(long* pnColor);
	STDMETHODIMP	put_BackgroundColor(long nColor);
	STDMETHODIMP	get_BoldFont(VARIANT_BOOL* pbBold);
	STDMETHODIMP	put_BoldFont(VARIANT_BOOL bBold);
	STDMETHODIMP	get_ItalicFont(VARIANT_BOOL* pbItalic);
	STDMETHODIMP	put_ItalicFont(VARIANT_BOOL bItalic);
	STDMETHODIMP	get_BorderStyle(AmbientBorderType* pBorderType);
	STDMETHODIMP	put_BorderStyle(AmbientBorderType borderType);
	STDMETHODIMP	get_BorderColor(long* pnColor);
	STDMETHODIMP	put_BorderColor(long nColor);

	// f[^o
private:
	CEditView&	m_view;
	int			m_nTokenType;
	TokenCookie	m_nTokenCookie;
};


// CAutomationTextSearcher class definition
/////////////////////////////////////////////////////////////////////////////

///	ITextSearcher ̎
class CAutomationTextSearcher :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ITextSearcher,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ITextSearcher>
		> {
	// RXgN^
public:
	CAutomationTextSearcher(CAlphaEditController& editor);

	// \bh
public:
	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ITextSearcher)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ITextSearcher \bh
	STDMETHODIMP	put_FindWhat(BSTR bstrFindWhat);
	STDMETHODIMP	get_IgnoreCase(AmbientCaseFoldingType* pCaseFoldingType);
	STDMETHODIMP	put_IgnoreCase(AmbientCaseFoldingType caseFoldingType);
	STDMETHODIMP	get_IgnoreControls(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreControls(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreDiacritics(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreDiacritics(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreDigitScript(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreDigitScript(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreKashida(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreKashida(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnorePunctuations(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnorePunctuations(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreSymbols(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreSymbols(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreVowels(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreVowels(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreWhitespaces(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreWhitespaces(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_IgnoreWidth(VARIANT_BOOL* pbIgnore);
	STDMETHODIMP	put_IgnoreWidth(VARIANT_BOOL bIgnore);
	STDMETHODIMP	get_OnlyIdentifiers(VARIANT_BOOL* pbOnlyIdentifiers);
	STDMETHODIMP	put_OnlyIdentifiers(VARIANT_BOOL bOnlyIdentifiers);
	STDMETHODIMP	get_UseRegularExpression(VARIANT_BOOL* pbUseRegExp);
	STDMETHODIMP	put_UseRegularExpression(VARIANT_BOOL bUseRegExp);
	STDMETHODIMP	get_WholeWord(VARIANT_BOOL* pbWholeWord);
	STDMETHODIMP	put_WholeWord(VARIANT_BOOL bWholeWord);
	STDMETHODIMP	BookmarkAll(long* pcFound);
	STDMETHODIMP	FindNext(VARIANT_BOOL* pbFound);
	STDMETHODIMP	FindPrev(VARIANT_BOOL* pbFound);
	STDMETHODIMP	ReplaceAndNext(BSTR bstrReplaceWith, VARIANT_BOOL* pbFound);
	STDMETHODIMP	ReplaceAndPrev(BSTR bstrReplaceWith, VARIANT_BOOL* pbFound);

	// f[^o
private:
	CAlphaEditController&	m_editor;
};


// CConfigurations class definition
/////////////////////////////////////////////////////////////////////////////

///	IConfigurations ̎
class CConfigurations :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IConfigurations,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IConfigurations>
		> {
	// RXgN^
public:
	CConfigurations(CAlphaApp& app);

	// \bh
public:
	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IConfigurations)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IConfigurations \bh
	STDMETHODIMP	get__NewEnum(IUnknown** ppEnum);
	STDMETHODIMP	get_KeyboardSchemes(BSTR bstrScopeName, IKeyboardScheme** ppKeyboardScheme);
	STDMETHODIMP	get_Property(BSTR bstrName, BSTR* pbstrValue);
	STDMETHODIMP	put_Property(BSTR bstrName, BSTR bstrValue);
	STDMETHODIMP	AddDocumentType(BSTR bstrName, BSTR bstrFileSpec,
						BSTR bstrCommand = 0, VARIANT_BOOL bPrivate = VARIANT_FALSE);
	STDMETHODIMP	Apply();
	STDMETHODIMP	RemoveAllDocumentTypes();

	// f[^o
private:
	CAlphaApp&				m_app;
	map<wstring, wstring>	m_mapModifiedProperties;	// ύXꂽvpeB
};


// CKeyboardScheme class definition
/////////////////////////////////////////////////////////////////////////////

///	IKeyboardScheme ̎
class CKeyboardScheme :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IKeyboardScheme,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IKeyboardScheme>
		> {
	friend class CConfigurations;

	// RXgN^
public:
	CKeyboardScheme(CKeyboardMap& impl);

	// \bh
public:
	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IKeyboardScheme)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IKeyboardScheme \bh
	STDMETHODIMP	get_Name(BSTR* pbstrName);
	STDMETHODIMP	Assign(BSTR bstrKeyCombination, long nCommandId);
	STDMETHODIMP	CopyAllMaps();
	STDMETHODIMP	Load(BSTR bstrSchemeName);
	STDMETHODIMP	Save(BSTR bstrSchemeName);

	// f[^o
private:
	CKeyboardMap&						m_impl;
	wstring								m_strSchemeName;
	static map<wstring, VirtualKey>		m_mapKeyValues;
};


// CAutomationCommand class definition
/////////////////////////////////////////////////////////////////////////////

///	ICommand ̎
class CAutomationCommand :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<ICommand,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_ICommand>
		> {
	// RXgN^
public:
	CAutomationCommand(CAlphaApp& app, CommandId id);

	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(ICommand)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// ICommand \bh
	STDMETHODIMP	get_Checked(VARIANT_BOOL* pbChecked);
	STDMETHODIMP	get_Description(BSTR* pbstrDescription);
	STDMETHODIMP	get_Enabled(VARIANT_BOOL* pbEnabled);
	STDMETHODIMP	get_KeyCombination(BSTR* pbstrKeys);
	STDMETHODIMP	get_Name(BSTR* pbstrName);
	STDMETHODIMP	Execute();

	// f[^o
private:
	CAlphaApp&		m_app;
	const CommandId	m_id;
};


// CAutomationClipboardRing class definition
/////////////////////////////////////////////////////////////////////////////

///	IClipboardRing ̎
class CAutomationClipboardRing :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IClipboardRing,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IClipboardRing>
		> {
	// RXgN^
public:
	CAutomationClipboardRing(CClipboardRing& impl);

	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IClipboardRing)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IClipboardRing \bh
	STDMETHODIMP	get_Count(short* pnCount);
	STDMETHODIMP	get_Text(short nIndex, BSTR* pbstrText);
	STDMETHODIMP	Add(BSTR bstrText);
	STDMETHODIMP	Delete(short nIndex);
	STDMETHODIMP	DeleteAll();
	STDMETHODIMP	LimitCount(short nLimit);

	// f[^o
private:
	CClipboardRing&	m_impl;
};


// CScriptHost class definition
/////////////////////////////////////////////////////////////////////////////

///	IScriptHost ̎
class CScriptHost :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IScriptHost,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IScriptHost>
		>,
		public ISupportErrorInfoImpl<&IID_IScriptHost> {
	// RXgN^
public:
	CScriptHost(CAlphaScriptHost* pImpl);
	virtual ~CScriptHost();

	// \bh
protected:
	DWORD	VerifyCreationObject(CLSID& clsid);
	DWORD	VerifyRunningObject(IUnknown* pUnk, CLSID& clsid);

public:
	// IUnknown \bh
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IScriptHost)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch \bh
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IScriptHost \bh
	STDMETHODIMP	ConnectObject(IDispatch* pObject, BSTR bstrPrefix);
	STDMETHODIMP	CreateObject(BSTR bstrProgId, BSTR bstrPrefix, IDispatch** ppObject);
	STDMETHODIMP	DisconnectObject(IDispatch* pObject);
	STDMETHODIMP	Echo(SAFEARRAY* parr);
	STDMETHODIMP	get_Arguments(IArguments** ppArguments);
	STDMETHODIMP	get_BuildVersion(short* pnBuildVersion);
	STDMETHODIMP	get_FullName(BSTR* pbstrFullName);
	STDMETHODIMP	get_Interactive(VARIANT_BOOL* pbInteractive);
	STDMETHODIMP	get_Name(BSTR* pbstrName);
	STDMETHODIMP	get_Path(BSTR* pbstrPath);
	STDMETHODIMP	get_ScriptFullName(BSTR* pbstrScriptFullName);
	STDMETHODIMP	get_ScriptName(BSTR* pbstrScriptName);
	STDMETHODIMP	get_StdErr(IDispatch** ppStdErr);
	STDMETHODIMP	get_StdIn(IDispatch** ppStdIn);
	STDMETHODIMP	get_StdOut(IDispatch** ppStdOut);
	STDMETHODIMP	get_Timeout(long* pnTimeout);
	STDMETHODIMP	get_Version(BSTR* pbstrVersion);
	STDMETHODIMP	GetObject(BSTR bstrPathName, BSTR bstrProgId, BSTR bstrPrefix, IDispatch** ppObject);
	STDMETHODIMP	put_Interactive(VARIANT_BOOL bInteractive);
	STDMETHODIMP	Sleep(long nMilliseconds);
	STDMETHODIMP	Quit(short nExitCode = 0);

	// f[^o
private:
	CAlphaScriptHost*	m_pImpl;
};


// CArguments class definition
/////////////////////////////////////////////////////////////////////////////

///	IArguments ̎
class CArguments : 
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IArguments,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IArguments>
		> {
	// RXgN^
public:
	CArguments(const vector<wstring>& vecArgs);

	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IArguments)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// IArguments C^[tFCX
	STDMETHODIMP	get__NewEnum(IUnknown** ppEnum);
	STDMETHODIMP	get_Item(long nIndex, BSTR* pbstrArg);
	STDMETHODIMP	get_Length(long* pcArgs);
	STDMETHODIMP	get_Named(IDispatch** ppNamed);
	STDMETHODIMP	get_Unnamed(IDispatch** ppUnnamed);
	STDMETHODIMP	Count(long* pcArgs);
	STDMETHODIMP	ShowUsage();

	// f[^o
private:
	vector<wstring>	m_vecArgs;
};


// CNamedArguments class definition
/////////////////////////////////////////////////////////////////////////////

///	INamedArguments ̎
class CNamedArguments :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<INamedArguments,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_INamedArguments>
		> {
	// RXgN^
public:
	CNamedArguments(const map<wstring, wstring>& mapNamedArguments);

public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(INamedArguments)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// INamedArguments C^[tFCX
	STDMETHODIMP	get__NewEnum(IUnknown** ppEnum);
	STDMETHODIMP	get_Item(BSTR bstrName, BSTR *pbstrArgument);
	STDMETHODIMP	get_Length(long *pnLength);
	STDMETHODIMP	Count(long *pnCount);
	STDMETHODIMP	Exists(BSTR bstrName, VARIANT_BOOL* pbExists);
	STDMETHODIMP	_NewEnum(IUnknown** ppOut);

	// f[^o
private:
	map<wstring, wstring>	m_mapNamedArguments;
};


// CUnnamedArguments class definition
/////////////////////////////////////////////////////////////////////////////

///	IUnnamedArguments ̎
class CUnnamedArguments :
		public IUnknownImpl<MultiThreadedRefCount>,
		public IDispatchImpl<IUnnamedArguments,
			CPathTypeLibTypeInfoHolder<CAlphaTypeLibPath, &IID_IUnnamedArguments>
		> {
	// RXgN^
public:
	CUnnamedArguments(const vector<wstring>& vecUnnamedArguments);

public:
	// IUnknown C^[tFCX
	IMPLEMENT_UNKNOWN()
	BEGIN_INTERFACE_TABLE()
		IMPLEMENTS_LEFTMOST_INTERFACE(IUnnamedArguments)
		IMPLEMENTS_INTERFACE(IDispatch)
	END_INTERFACE_TABLE()

	// IDispatch C^[tFCX
	STDMETHODIMP	Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
						WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult,
						EXCEPINFO* pExcepInfo, unsigned int* puArgErr);

	// INamedArguments C^[tFCX
	STDMETHODIMP	get__NewEnum(IUnknown** ppEnum);
	STDMETHODIMP	get_Item(long iArgument, BSTR *pbstrArgument);
	STDMETHODIMP	get_Length(long *pnLength);
	STDMETHODIMP	Count(long *pnCount);
	STDMETHODIMP	_NewEnum(IUnknown** ppOut);

	// f[^o
private:
	vector<wstring>	m_vecUnnamedArguments;
};

} /* namespace Ambient */
} /* namespace Alpha */

#endif /* _AMBIENT_H_ */

/* [EOF] */